;; -*- lexical-binding: t; -*-
(require 'ewoc)

(defvar testewoc-ewoc nil)

(defun testewoc-pp (data)
  (let ((c (string-to-char (number-to-string data))))
    (insert (make-string (random 30) c))
    (dotimes (_i (random 5))
      (insert (format "\n%s"
                      (make-string (random 30) c))))))

(defun testewoc ()
  (interactive)
  (switch-to-buffer
   (get-buffer-create "*testewoc buffer*"))
  (kill-all-local-variables)
  (setq major-mode 'testewoc-mode
        mode-name "Test Ewoc")
  (erase-buffer)
  (buffer-disable-undo)
  (let ((ewoc (ewoc-create 'testewoc-pp "-header-" "-footer-" t)))
    (set (make-local-variable 'testewoc-ewoc) ewoc)
    (ewoc-enter-last ewoc 0)
    (ewoc-enter-last ewoc 1)
    (ewoc-enter-last ewoc 2)))

(defun testewoc-invalidate ()
  (interactive)
  (ewoc-invalidate testewoc-ewoc
                   (ewoc-nth testewoc-ewoc 0)
                   (ewoc-nth testewoc-ewoc 1)
                   (ewoc-nth testewoc-ewoc 2)))
